/*
 * Copyright (C) 2009 Castrense Savojardo
 * 	Bologna Biocomputing Group
 * 	University of Bologna, Italy
 *  savojard@biocomp.unibo.it
 * 
 * This file is part of BioCRF
 * 
 * BioCRF is a free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * BioCRF is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BioCRF; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 * 
 */
#ifndef FEATURE_H_
#define FEATURE_H_
#include <set>
#include <string>
#define TRANS_FEATURE 0
#define STATE_FEATURE 1

namespace features {
	
class Feature
{
public:

	int key;
	int from_state;
	int to_state;
	int window_offset;
	int cp;
	int type;
	
	double weight;

	Feature(int to_state, int window_offset, int cp);
	
	Feature(int to_state, int from_state);
	
	virtual ~Feature();
};

}
#endif /*FEATURE_H_*/

