/*
 * Copyright (C) 2009 Castrense Savojardo
 * 	Bologna Biocomputing Group
 * 	University of Bologna, Italy
 *  savojard@biocomp.unibo.it
 * 
 * This file is part of BioCRF
 * 
 * BioCRF is a free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * BioCRF is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BioCRF; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 * 
 */
#ifndef FEATURESET_H_
#define FEATURESET_H_
#include <vector>
#include <map>
#include <fstream>
#include "Feature.h"

 
namespace models {
	class Model;
}

namespace features {
class FeatureSet
{		
public:
	
	models::Model * model;
	
	std::vector<Feature> features;
	//std::vector<Feature> trans_features;
	std::vector<int> trans_features;
	std::map<std::string,int> fid_map;
	std::multimap<int, std::pair<int, int > > dictionary;
	//std::map<int,double> tfv;

	int num_features;
	
	FeatureSet();
	FeatureSet(std::ifstream * model_file);
	virtual ~FeatureSet();
	void gen_features();
	void assign_features();
	//void assign_features_multi_threaded();
	int add(int window_offset, int cp, int to_state);
	int add(int to_state, int from_state);
	void dump();
	void dump(std::ofstream * os);
private:
	void read_dictionary(std::ifstream * model_file);
	void read_features(std::ifstream * model_file);
	//void do_thread(int index);
};

}
#endif /*FEATURESET_H_*/

