/*
 * Copyright (C) 2009 Castrense Savojardo
 * 	Bologna Biocomputing Group
 * 	University of Bologna, Italy
 *  savojard@biocomp.unibo.it
 * 
 * This file is part of BioCRF
 * 
 * BioCRF is a free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * BioCRF is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BioCRF; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 * 
 */
#ifndef MATHLIBEXCEPTION_H_
#define MATHLIBEXCEPTION_H_
#include <string>

namespace mathlib {

class MathlibException
{
public:
	MathlibException();
	virtual ~MathlibException();
	
	virtual void report();
};

class MathlibIncompatibleSizeException : public MathlibException
{
protected:
	std::string classname;
public:
	MathlibIncompatibleSizeException(std::string classname);
	virtual ~MathlibIncompatibleSizeException();
	
	void report();
};

class MathlibIndexOutOfRangeException : public MathlibException
{
protected:	
	std::string classname;
public:
	MathlibIndexOutOfRangeException(std::string classname);
	virtual ~MathlibIndexOutOfRangeException();
	
	void report();
};

class MathlibNoValidSizeException : public MathlibException
{
protected:	
	std::string classname;
public:
	MathlibNoValidSizeException(std::string classname);
	virtual ~MathlibNoValidSizeException();
	
	void report();
};
}

#endif /*MATHLIBEXCEPTION_H_*/

