/*
 * Copyright (C) 2009 Castrense Savojardo
 * 	Bologna Biocomputing Group
 * 	University of Bologna, Italy
 *  savojard@biocomp.unibo.it
 * 
 * This file is part of BioCRF
 * 
 * BioCRF is a free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * BioCRF is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BioCRF; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 * 
 */
#ifndef TRAINERDG_H_
#define TRAINERDG_H_
#include "Trainer.h"
#include "DoubleMatrix.h"
#include "DoubleVector.h"
#include "ForwardBackward.h"
#include "Model.h"

namespace training {
	
class TrainerDG : public Trainer
{
protected:
	algo::ForwardBackward * fb_free, * fb_clamped;
public:
	TrainerDG(models::Model * model);
	~TrainerDG();
	void train_LCRF();
	void train_GRCRF();
	
private:
	double compute_cond_log_likelihood(double * gradient, double * lambda);
};

}
#endif /*TRAINERDG_H_*/

