/*
 * Copyright (C) 2009 Castrense Savojardo
 * 	Bologna Biocomputing Group
 * 	University of Bologna, Italy
 *  savojard@biocomp.unibo.it
 * 
 * Decoder.cpp - This file is part of BioCRF
 * 
 * BioCRF is a free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * BioCRF is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BioCRF; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 * 
 */
#include "Decoder.h"
#include "Data.h"
#include "Viterbi.h"
#include "Model.h"

namespace decoding {

void Decoder::init()
{	
	int i;
	
	int num_features = model->featureset->num_features;
	
	this->lambda = new double[num_features];
	
	for (i=0; i<num_features; i++){
		this->lambda[i] = model->featureset->features[i].weight;
	}
	this->vt = new algo::Viterbi(1, model->transducer->num_states);
	this->vt->bos = model->options->include_bos_feature;
	this->vt->eos = model->options->include_eos_feature;
}

void Decoder::decode() 
{
	int seq = 0;
	data::Dataset::iterator datait;
	
	for (datait = this->model->data->ds->begin() ; 
		datait != this->model->data->ds->end(); datait++) {
		std::cout << "Predicting sequence " << seq << std::endl;
	
		this->predict(*datait);
		seq++;
	}
}
}
