/*
 * Copyright (C) 2009 Castrense Savojardo
 * 	Bologna Biocomputing Group
 * 	University of Bologna, Italy
 *  savojard@biocomp.unibo.it
 * 
 * GrammarException.cpp - This file is part of BioCRF
 * 
 * BioCRF is a free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * BioCRF is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BioCRF; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 * 
 */
#include <iostream>
#include <stdlib.h>
#include "GrammarException.h"

namespace grammar {
GrammarException::GrammarException()
{
}

GrammarException::~GrammarException()
{
}

void GrammarException::report()
{
	std::cout << "Grammar exception. Exit." << std::endl;
	exit(EXIT_FAILURE);
}

GrammarNumberOfStatesException::GrammarNumberOfStatesException()
{
}

GrammarNumberOfStatesException::~GrammarNumberOfStatesException()
{
}

void GrammarNumberOfStatesException::report()
{
	std::cout << "Grammar Exception: Number of states in topology file invalid or missing" << std::endl;
	exit(EXIT_FAILURE);
}

GrammarLabelsException::GrammarLabelsException()
{
}

GrammarLabelsException::~GrammarLabelsException()
{
}

void GrammarLabelsException::report()
{
	std::cout << "Grammar Exception: Number of labels in topology file invalid or invalid mapped label" << std::endl;
	exit(EXIT_FAILURE);
}

GrammarLabelMappingSectionException::GrammarLabelMappingSectionException()
{
}
GrammarLabelMappingSectionException::~GrammarLabelMappingSectionException()
{
}
void GrammarLabelMappingSectionException::report()
{
	std::cout << "Grammar Exception: Invalid label mapping section in topology file" << std::endl;
	exit(EXIT_FAILURE);
}

GrammarStateMappingSectionException::GrammarStateMappingSectionException()
{
}
GrammarStateMappingSectionException::~GrammarStateMappingSectionException()
{
}
void GrammarStateMappingSectionException::report()
{
	std::cout << "Grammar Exception: Invalid state mapping section in topology file" << std::endl;
	exit(EXIT_FAILURE);
}

GrammarStateTransitionsSectionException::GrammarStateTransitionsSectionException()
{
}
GrammarStateTransitionsSectionException::~GrammarStateTransitionsSectionException()
{
}
void GrammarStateTransitionsSectionException::report()
{
	std::cout << "Grammar Exception: Invalid state transitions section in topology file" << std::endl;
	exit(EXIT_FAILURE);
}

}
