/*
 * Copyright (C) 2009 Castrense Savojardo
 * 	Bologna Biocomputing Group
 * 	University of Bologna, Italy
 *  savojard@biocomp.unibo.it
 * 
 * ModelFactory.cpp - This file is part of BioCRF
 * 
 * BioCRF is a free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * BioCRF is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BioCRF; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 * 
 */
#include <iostream>
#include "ModelFactory.h"
#include "GRCRF.h"

namespace models {

ModelFactory::ModelFactory()
{
	
}

ModelFactory::~ModelFactory()
{
	
}

Model * ModelFactory::get_empty_model(options::Options * options)
{
        Model * res;

        switch(options->model) {
                case GRCRFM:
                        std::cout << "Creating model" << std::endl;
                        res = new GRCRF();
                        break;
                default:
                        break;
        }

        return res;
}

Model * ModelFactory::get_model(options::Options * options) 
{
	Model * res;
	
	switch(options->model) {
		case GRCRFM:
			std::cout << "Creating GRCRF model" << std::endl;
			res = new GRCRF(options);
			break;
		default:
			break;
	}
	
	return res;
}

}
